// mod to the Demo for quad alphanumeric display LED backpack kit to display across two backpacks
// scrolls through every character, then scrolls Serial
// input onto the display

#include <Wire.h>
#include <Adafruit_GFX.h>
#include "Adafruit_LEDBackpack.h"

// label the displays with their i2c addresses
struct {
  uint8_t           addr;         // I2C address
  Adafruit_AlphaNum4 alpha4;         
} disp[] = {
  { 0x70, Adafruit_AlphaNum4() },  // left-hand display
  { 0x72, Adafruit_AlphaNum4() },  // middle display
  { 0x71, Adafruit_AlphaNum4() },  // right-hand display
};

void setup() {
  Serial.begin(115200);
  
  for(uint8_t i=0; i<3; i++) {       // Initialize 3 displays
    disp[i].alpha4.begin(disp[i].addr);
    disp[i].alpha4.clear();
    disp[i].alpha4.writeDisplay();
  }

  // display every character 
  for (uint8_t i='!'; i<='z'; i++) {
    disp[0].alpha4.writeDigitAscii(0, i);
    disp[0].alpha4.writeDigitAscii(1, i+1);
    disp[0].alpha4.writeDigitAscii(2, i+2);
    disp[0].alpha4.writeDigitAscii(3, i+3);
    disp[1].alpha4.writeDigitAscii(0, i+4);
    disp[1].alpha4.writeDigitAscii(1, i+5);
    disp[1].alpha4.writeDigitAscii(2, i+6);
    disp[1].alpha4.writeDigitAscii(3, i+7);
    disp[2].alpha4.writeDigitAscii(0, i+8);
    disp[2].alpha4.writeDigitAscii(1, i+9);
    disp[2].alpha4.writeDigitAscii(2, i+10);
    disp[2].alpha4.writeDigitAscii(3, i+11);
    disp[0].alpha4.writeDisplay();
    disp[1].alpha4.writeDisplay();
    disp[2].alpha4.writeDisplay();
    delay(300);
  }
  Serial.println("Start typing to display!");
}

char displaybuffer[12] = {' ', ' ', ' ', ' ',' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '};

void loop() {
  while (! Serial.available()) return;
  
  char c = Serial.read();
  if (! isprint(c)) return; // only printable!
  
  // scroll down display
  displaybuffer[0] = displaybuffer[1];
  displaybuffer[1] = displaybuffer[2];
  displaybuffer[2] = displaybuffer[3];
  displaybuffer[3] = displaybuffer[4];
  displaybuffer[4] = displaybuffer[5];
  displaybuffer[5] = displaybuffer[6];
  displaybuffer[6] = displaybuffer[7];
  displaybuffer[7] = displaybuffer[8];
  displaybuffer[8] = displaybuffer[9];
  displaybuffer[9] = displaybuffer[10];
  displaybuffer[10] = displaybuffer[11];
  displaybuffer[11] = c;
 
  // set every digit to the buffer
  disp[0].alpha4.writeDigitAscii(0, displaybuffer[0]);
  disp[0].alpha4.writeDigitAscii(1, displaybuffer[1]);
  disp[0].alpha4.writeDigitAscii(2, displaybuffer[2]);
  disp[0].alpha4.writeDigitAscii(3, displaybuffer[3]);
  disp[1].alpha4.writeDigitAscii(0, displaybuffer[4]);
  disp[1].alpha4.writeDigitAscii(1, displaybuffer[5]);
  disp[1].alpha4.writeDigitAscii(2, displaybuffer[6]);
  disp[1].alpha4.writeDigitAscii(3, displaybuffer[7]);
  disp[2].alpha4.writeDigitAscii(0, displaybuffer[8]);
  disp[2].alpha4.writeDigitAscii(1, displaybuffer[9]);
  disp[2].alpha4.writeDigitAscii(2, displaybuffer[10]);
  disp[2].alpha4.writeDigitAscii(3, displaybuffer[11]);
 
  // write it out!
  disp[0].alpha4.writeDisplay();
  disp[1].alpha4.writeDisplay();
  disp[2].alpha4.writeDisplay();
  delay(200);
}
